# Class CommandBase

java.lang.Object
org.apache.zookeeper.server.admin.CommandBase

All Implemented Interfaces:
  `Command`

Direct Known Subclasses:
  `GetCommand, PostCommand`

public abstract class CommandBase extends Object implements Command

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`CommandBase(List<String> names)`
`protected`
`CommandBase(List<String> names, boolean serverRequired)`
`protected`
`CommandBase(List<String> names, boolean serverRequired, AuthRequest authRequest)`

## Method Summary

Modifier and Type
Method
Description
`AuthRequest`
`getAuthRequest()`
`Set<String>`
`getNames()`
The set of all names that can be used to refer to this command (e.g., "configuration", "config", and "conf").
`String`
`getPrimaryName()`
The name that is returned with the command response and that appears in the list of all commands.
`protected CommandResponse`
`initializeResponse()`
`boolean`
`isServerRequired()`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface Command

`runGet, runPost`

## Constructor Details

### CommandBase

protected CommandBase(List<String> names)

Parameters:
  `names` - The possible names of this command, with the primary name first.

### CommandBase

protected CommandBase(List<String> names, boolean serverRequired)

### CommandBase

protected CommandBase(List<String> names, boolean serverRequired, AuthRequest authRequest)

## Method Details

### getPrimaryName

public String getPrimaryName()
Description copied from interface: `Command`
The name that is returned with the command response and that appears in the list of all commands. This should be a member of the set returned by getNames().

Specified by:
  `getPrimaryName` in interface `Command`

### getNames

public Set<String> getNames()
Description copied from interface: `Command`
The set of all names that can be used to refer to this command (e.g., "configuration", "config", and "conf").

Specified by:
  `getNames` in interface `Command`

### isServerRequired

public boolean isServerRequired()

Specified by:
  `isServerRequired` in interface `Command`
Returns:
  true if the command requires an active ZooKeeperServer or a synced peer in order to resolve

### getAuthRequest

public AuthRequest getAuthRequest()

Specified by:
  `getAuthRequest` in interface `Command`
Returns:
  AuthRequest associated to the command. Null means auth check is not required.

### initializeResponse

protected CommandResponse initializeResponse()

Returns:
  A response with the command set to the primary name and the error set to null (these are the two entries that all command responses are required to include).